' Jay's Icon Resizer - 2018 edition

' ToDo
'   Add PaperArcade back into the mix!  \o/

'   Add Windows .ico format export, preferably with the following icons all in one single file.
' 		 Icon 		Bits
		' 256 			32
		' 48		8	32
		' 32	4	8	32
		' 16	4	8	32

' -=-=-=-

Global GetIni$=RequestFile("Select .ini file","ini")
If FileType(GetIni$)=0 Then End

Global jscrw=800
Global jscrh=600
Graphics jscrw,jscrh,0
						SetBlend 3;AutoMidHandle True

Global Home$=CurrentDir$()

Global RawIcon:TPixmap[2050]
Global RawMisc:TPixmap[128]
Global RawScreen:TPixmap[128]
Global tPix:TPixmap
Global RawScreenName$[128]
Global IconTot=0, MiscTot=0, ScreenTot=0, MadeTot=0

Global ScreenIcon:TImage
Global ScreenLogo:TImage
Global iniFile=ReadFile(GetIni$)
Global iniType$,iniFilename$,iniWidth,iniHeight,iniFilled,iniJpeg,iniOverlay,iniOverscan, iniBadge, iniIcon



SetClsColor(80,20,20)
	GetAssets()


	
SetClsColor(20,80,20)
	Update("Generating")
	
	ChangeDir(home$)
	If FileType("02 - Output")=0 Then CreateDir("02 - Output")
	ChangeDir(home$+"/02 - Output")

	Repeat
		iniType$=Upper$(Trim$(ReadLine(iniFile)))
'		DebugLog iniType
		
		use=0
		If initype$="ICONS" Or iniType$="ICON" Then use=1
		If iniType$="SCREENSHOTS" Or iniType$="SCREENS" Or iniType="SCREENSHOT" Or iniType="SCREEN" Then use=2
		If initype$="BACKING" Or iniType$="LAUNCH" Or iniType$="PLAIN" Then use=3
		If initype$="FEATURE" Or iniType$="HEADER" Or iniType$="BANNER" Then use=4
		
		
		If use>0
			iniA$=Trim$(ReadLine(iniFile))
			iniB$=Trim$(ReadLine(iniFile))
			iniFilename$=iniA$
			folder$=SplitText(iniA$,"/",1)
			If FileType(folder)=0 Then CreateDir(folder)
			
			wtxt$=SplitText(iniB$,",",1)
			If Instr(wtxt$,"x")>0 Then iniWidth=Abs(Int(SplitText(wtxt$,"x",1)));iniHeight=Abs(Int(SplitText(wtxt$,"x",2)))
			If Instr(wtxt$,"x")=0 Then iniWidth=Abs(Int(wtxt$));iniHeight=iniWidth
			
			iniFilled=0;iniJpeg=0;iniOverlay=0;iniOverscan=0;iniBadge=0;iniIcon=0
			If Instr(Lower$(iniB$),"filled")>0 Then iniFilled=1
			If Instr(Lower$(iniB$),"full")>0 Then iniFilled=1
			If Instr(Lower$(iniB$),"jpeg")>0 Then iniJpeg=1
			If Instr(Lower$(iniB$),"jpg")>0 Then iniJpeg=1
			If Instr(Lower$(iniB$),"overlay")>0 Then iniOverlay=1
			If Instr(Lower$(iniB$),"overscan")>0 Then iniOverscan=1
			If Instr(Lower$(iniB$),"padding")>0 Then iniOverscan=1
			If Instr(Lower$(iniB$),"badge")>0 Then iniBadge=1
			If Instr(Lower$(iniB$),"logo")>0 Then iniBadge=1
			If Instr(Lower$(iniB$),"icon")>0 Then iniIcon=1
			
			


			DebugLog "Creating "+Lower(iniType)+" at "+iniFilename+" with size "+iniWidth+","+iniHeight	
			
			If use=1 Then CreateStandardIcon()
			If use=2 Then CreateScreenshotPack()
			If use=3 Then CreateLaunchImage()
			If use=4 Then CreateFeaturePack()

		EndIf
		If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_F4) Then End
		
	Until Eof(iniFile)
CloseFile iniFile
		
SetClsColor(40,40,180)
	Update("Finished")

WaitKey()



Function CreateStandardIcon()
	Update("Generating Icon",iniFilename$,"@ "+iniWidth+" x "+iniHeight)
	bestfit=5000
	For n=1 To 2048
		If RawIcon[n] And Abs(n-iniWidth)<Abs(bestfit-iniWidth)
			bestfit=n
		EndIf
	Next
	If bestfit<5000
		OutIcon:TPixmap=CreatePixmap(iniWidth,iniHeight,PF_RGBA8888)
		OutBack:TPixmap=ResizePixmap(RawMisc[1],iniWidth,iniHeight)

		OutFace:TPixmap=ResizePixmap(RawIcon[bestfit],iniWidth,iniHeight)
		For x=0 To iniWidth-1
		For y=0 To iniHeight-1
			argb1=$00000000
			If iniFilled=1
				argb2=ReadPixel(outBack,x,y)
				argb1=AlphaBlend(argb1,argb2)
			EndIf
			argb2=ReadPixel(outFace,x,y)
			argb1=AlphaBlend(argb1,argb2)
			WritePixel(outIcon,x,y,argb1)
		Next
		Next

		If iniJpeg=0 Then SavePixmapPNG(outicon,iniFilename$+".png")
		If iniJpeg=1 Then SavePixmapPNG(outicon,iniFilename$+".jpg")
		OutIcon=Null
		OutBack=Null
		OutFace=Null
		If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_F4) Then End

		MadeTot=MadeTot+1
	EndIf
End Function


Function CreateScreenshotPack()
subfolder$=splittext(iniFilename$,"/",2)
If FileType(iniFilename$)=0 Then CreateDir(iniFilename$)
didshots=0

	For n=0 To 127
		If RawScreen[n]<>Null And RawScreenName[n]<>""
			didshots=didshots+1
			Update("Scaling Screenshots",iniFilename$+" @ "+iniWidth+" x "+iniHeight,didshots+"/"+ScreenTot)
			
			tPix:TPixmap=CreatePixmap(iniWidth,iniHeight,PF_RGBA8888)
			toWidth=iniWidth
			toHeight=Ceil(PixmapHeight(RawScreen[n])*iniWidth)/PixmapWidth(RawScreen[n])
			If toHeight<iniHeight
				toHeight=iniHeight
				toWidth=Ceil(PixmapWidth(RawScreen[n])*iniHeight)/PixmapHeight(RawScreen[n])
			EndIf
			' Add a buffer, because ..fuck..
			toWidth=toWidth+2
			toHeight=toHeight+2
			tpix2:TPixmap=ResizePixmap(RawScreen[n],toWidth,toHeight)
			
			DebugLog "Target          "+iniWidth+"x"+iniHeight
			DebugLog "Image scaled to "+toWidth+"x"+toHeight
			
			' Now grab the middle
			cx=((toWidth-1)/2)-(iniWidth/2)
			cy=((toHeight-1)/2)-(iniHeight/2)
			If cx<0 Then cx=0
			If cy<0 Then cy=0
			If cx+iniWidth>toWidth-1 Then cx=(toWidth-1)-iniWidth
			If cy+iniHeight>toHeight-1 Then cy=(toHeight-1)-iniHeight
			
			For x=0 To iniWidth-1
			For y=0 To iniHeight-1
				argb=00000000
				If x+cx>-1 And x+cx<toWidth And y+cy>-1 And y+cy<toHeight Then argb=ReadPixel(tpix2,x+cx,y+cy)
				WritePixel(tpix,x,y,argb)
			Next
			Next
			
			If iniJpeg=0 Then SavePixmapPNG(tpix,iniFilename$+"/"+RawScreenName[n]+".png")
			If iniJpeg=1 Then SavePixmapJPeg(tpix,iniFilename$+"/"+RawScreenName[n]+".jpg")
			
			tPix=Null;tPix2=Null
			MadeTot=MadeTot+1
		EndIf
		If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_F4) Then End
	Next
End Function



Function CreateLaunchImage()
	tpix:TPixmap=CreatePixmap(iniWidth,iniHeight,PF_RGBA8888)

	Update("Generating Plain Logo",iniFilename$,iniWidth+" x "+iniHeight)
	
	w=iniWidth
	If iniHeight>w Then w=iniHeight
	w=w+4;h=w
	tPix2:TPixmap=ResizePixmap(RawMisc[1],w,w)
	
	cx=(w/2)-(iniWidth/2)
	cy=(h/2)-(iniHeight/2)
	If cx<0 Then cx=0
	If cy<0 Then cy=0
	If cx+iniWidth>w Then cx=w-iniWidth
	If cy+iniHeight>h Then cy=h-iniHeight

	For x=0 To iniWidth-1
	For y=0 To iniHeight-1
		argb=$FF000000
		If x+cx>-1 And x+cx<w And y+cy>-1 And y+cy<h Then argb=ReadPixel(tpix2,x+cx,y+cy)
		WritePixel(tpix,x,y,argb)
	Next
	Next
	
	tw=iniWidth-4
	th=iniHeight-4
	If iniOverscan=1 Then tw=tw*0.75;th=th*0.75
	
	scale#=2.0
	Repeat
		w=(Float(PixmapWidth(RawMisc[0]))*scale)
		h=(Float(PixmapHeight(RawMisc[0]))*scale)
		scale=scale-0.025
	Until w<tw And h<th
	DebugLog "size picked : "+w+":"+h

	tpix2=ResizePixmap(RawMisc[0],w,h)
	
	cx=((iniWidth-1)/2)-(w/2)
	cy=((iniHeight-1)/2)-(h/2)
	If cx<0 Then cx=0
	If cy<0 Then cy=0
	If cx+w>iniWidth-1 Then cx=(iniWidth-1)-w
	If cy+h>iniHeight-1 Then cy=(iniHeight-1)-h

	For x=0 To w-1
	For y=0 To h-1
		argb2=ReadPixel(tpix2,x,y)
		If x+cx>-1 And x+cx<iniWidth And y+cy>-1 And y+cy<iniHeight
			argb=ReadPixel(tpix,x+cx,y+cy)
			argb=AlphaBlend(argb,argb2)
			WritePixel(tpix,x+cx,y+cy,argb)
		EndIf
	Next
	Next
	
	If iniJpeg=0 Then SavePixmapPNG(tpix,iniFilename$+".png")
	If iniJpeg=1 Then SavePixmapJPeg(tpix,iniFilename$+".jpg")
	
	MadeTot=MadeTot+1
	
	tpix=Null;tPix2=Null
	If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_F4) Then End	
End Function


Function CreateFeaturePack()
subfolder$=splittext(iniFilename$,"/",2)
If FileType(iniFilename$)=0 Then CreateDir(iniFilename$)
didshots=0

	For n=0 To 127
		If RawScreen[n]<>Null And RawScreenName[n]<>""
			didshots=didshots+1
			Update("Creating Features",iniFilename$+" @ "+iniWidth+" x "+iniHeight,didshots+"/"+ScreenTot)
			
			tPix:TPixmap=CreatePixmap(iniWidth,iniHeight,PF_RGBA8888)
			toWidth=iniWidth
			toHeight=Ceil(PixmapHeight(RawScreen[n])*iniWidth)/PixmapWidth(RawScreen[n])
			If toHeight<iniHeight
				toHeight=iniHeight
				toWidth=Ceil(PixmapWidth(RawScreen[n])*iniHeight)/PixmapHeight(RawScreen[n])
			EndIf
			' Add a buffer, because ..fuck..
			toWidth=toWidth+2
			toHeight=toHeight+2
			tpix2:TPixmap=ResizePixmap(RawScreen[n],toWidth,toHeight)
			
			DebugLog "Target          "+iniWidth+"x"+iniHeight
			DebugLog "Image scaled to "+toWidth+"x"+toHeight
			
			' Now grab the middle
			cx=((toWidth-1)/2)-(iniWidth/2)
			cy=((toHeight-1)/2)-(iniHeight/2)
			If cx<0 Then cx=0
			If cy<0 Then cy=0
			If cx+iniWidth>toWidth-1 Then cx=(toWidth-1)-iniWidth
			If cy+iniHeight>toHeight-1 Then cy=(toHeight-1)-iniHeight
			
			For x=0 To iniWidth-1
			For y=0 To iniHeight-1
				argb=00000000
				If x+cx>-1 And x+cx<toWidth And y+cy>-1 And y+cy<toHeight Then argb=ReadPixel(tpix2,x+cx,y+cy)
				WritePixel(tpix,x,y,argb)
			Next
			Next

' Step 2 - Add Logo to center
			tw=iniWidth-4
			th=iniHeight-4
			If iniOverscan=1 Then tw=tw*0.75;th=th*0.75
			
			scale#=2.0
			Repeat
				w=(Float(PixmapWidth(RawMisc[0]))*scale)
				h=(Float(PixmapHeight(RawMisc[0]))*scale)
				scale=scale-0.025
			Until w<tw And h<th
			DebugLog "size picked : "+w+":"+h
		
			tpix2=ResizePixmap(RawMisc[0],w,h)
			
			cx=((iniWidth-1)/2)-(w/2)
			cy=((iniHeight-1)/2)-(h/2)
			If cx<0 Then cx=0
			If cy<0 Then cy=0
			If cx+w>iniWidth-1 Then cx=(iniWidth-1)-w
			If cy+h>iniHeight-1 Then cy=(iniHeight-1)-h
		
			For x=0 To w-1
			For y=0 To h-1
				argb2=ReadPixel(tpix2,x,y)
				If x+cx>-1 And x+cx<iniWidth And y+cy>-1 And y+cy<iniHeight
					argb=ReadPixel(tpix,x+cx,y+cy)
					argb=AlphaBlend(argb,argb2)
					WritePixel(tpix,x+cx,y+cy,argb)
				EndIf
			Next
			Next


If iniOverlay=1
	For over=2 To MiscTot
		If PixmapWidth(RawMisc[over])=iniWidth And PixmapHeight(RawMisc[over])=iniHeight
			For x=0 To iniWidth-1
			For y=0 To iniHeight-1
				argb=ReadPixel(tpix,x,y)
				argb2=ReadPixel(RawMisc[over],x,y)
				argb=AlphaBlend(argb,argb2)
				WritePixel(tpix,x,y,argb)
			Next
			Next
		EndIf
	Next
EndIf

If iniBadge=1
	cx=2
	If iniOverscan=1 Then cx=iniWidth*0.2;cy=iniHeight*0.2
	For x=0 To PixmapWidth(RawMisc[2])-1
	For y=0 To PixmapHeight(RawMisc[2])-1
		If x+cx>0 And y+cy>0 And x+cx<iniWidth And y+cy<iniHeight
				argb=ReadPixel(tpix,x+cx,y+cy)
				argb2=ReadPixel(RawMisc[2],x,y)
				argb=AlphaBlend(argb,argb2)
				WritePixel(tpix,x+cx,y+cy,argb)			
		EndIf
	Next
	Next
EndIf

If iniIcon=1
	bestfit=5000
	For m=1 To 2048
		If RawIcon[m] And Abs(m-iniWidth)<Abs(bestfit-iniWidth)
			bestfit=m
		EndIf
	Next
	If bestfit<5000
	tpix2:TPixmap=ResizePixmap(RawIcon[bestfit],128,128)
	cx=iniWidth-130
	cy=iniHeight-130
	If iniOverscan=1 Then cx=(iniWidth*0.8)-130;cy=(iniHeight*0.8)-130
	
	For x=0 To 127
	For y=0 To 127
		If x+cx>0 And y+cy>0 And x+cx<iniWidth And y+cy<iniHeight
				argb=ReadPixel(tpix,x+cx,y+cy)
				argb2=ReadPixel(tpix2,x,y)
				argb=AlphaBlend(argb,argb2)
				WritePixel(tpix,x+cx,y+cy,argb)			
		EndIf
	Next
	Next
	EndIf
	
EndIf


			
			If iniJpeg=0 Then SavePixmapPNG(tpix,iniFilename$+"/"+RawScreenName[n]+".png")
			If iniJpeg=1 Then SavePixmapJPeg(tpix,iniFilename$+"/"+RawScreenName[n]+".jpg")
			MadeTot=MadeTot+1
			
			tPix=Null;tPix2=Null
		EndIf
		If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_F4) Then End
	Next
End Function






Function AlphaBlend(argb,argb2)
					ra#=(argb2 & $FF000000) Shr 24
					ba#=(argb & $FF000000) Shr 24
					
					r1#=(argb & $FF0000) Shr 16
					r2#=(argb2 & $FF0000) Shr 16
					g1#=(argb & $FF00) Shr 8
					g2#=(argb2 & $FF00) Shr 8
					b1#=(argb & $FF) 
					b2#=(argb2 & $FF)

					nr#=r1-(((r1-r2)/255)*ra#)
					If nr<0 Then nr=0
					If nr>255 Then nr=255
					ng#=g1-(((g1-g2)/255)*ra#)
					If ng<0 Then ng=0
					If ng>255 Then ng=255
					nb#=b1-(((b1-b2)/255)*ra#)
					If nb<0 Then nb=0
					If nb>255 Then nb=255
					
					If ra=<4 And ba<4 Then Return $00000000
					Return $FF000000+(Int(nr) Shl 16)+(Int(ng) Shl 8)+Int(nb)
End Function


Function GetAssets() 
If FileType("01 - Input")=0 Then CreateDir("01 - Input")

ChangeDir(Home$+"/01 - Input")
If FileType("Icons")=0 Then CreateDir("Icons")
ChangeDir(Home$+"/01 - Input/Icons")

Update("Loading Icons")

quickdir=ReadDir(CurrentDir$())
near=5000
Repeat
in$=NextFile(quickdir)
If Upper$(Right$(in$,4))=".PNG"
	timg:TImage=LoadImage(in$)
		w=ImageWidth(timg)
		If w>0 And w<2049
			RawIcon[w]=LoadPixmapPNG(in$);IconTot=IconTot+1
			If ImageHeight(timg)<>w Then RawIcon[w]=ResizePixmap(RawIcon[w],w,w)
			Update("Loading Icons")
			If Abs(w-128)<Abs(near-128)
				tpix:TPixmap=ResizePixmap(RawIcon[w],128,128);near=w;ScreenIcon=LoadImage(tpix);tpix=Null
			EndIf
		EndIf
	timg=Null
EndIf
Until in$=""
CloseDir quickdir

Update("Loading Misc")
GCCollect()
ChangeDir(Home$+"/01 - Input")
If FileType("Misc")=0 Then CreateDir("Misc")
ChangeDir(Home$+"/01 - Input/Misc")


If FileType("logo.png")
	tpix:TPixmap=LoadPixmapPNG("logo.png")
	w=PixmapWidth(tpix)
	h=PixmapHeight(tpix)
	nh=Int((Float(h)*Float(jscrw))/Float(w))
	tpix:TPixmap=ResizePixmap(tpix,jscrw,nh);ScreenLogo=LoadImage(tpix)
	
	upscale=4
	RawMisc[0]=CreatePixmap(PixmapWidth(tpix)*upscale,PixmapHeight(tpix)*upscale,PF_RGBA8888)
		' Pixel-based resize of logo.
	For x=0 To PixmapWidth(tpix)-1
	For y=0 To PixmapHeight(tpix)-1
		argb=ReadPixel(tpix,x,y)
		For ox=0 To upscale-1
		For oy=0 To upscale-1
			WritePixel(RawMisc[0],(x*upscale)+ox,(y*upscale)+oy,argb)
		Next
		Next
	Next
	Next

	tpix=Null

Else

	Cls;SetColor(255,255,255);SetAlpha(1.0);SetBlend(1.0)
	DrawText("Logo Missing",16,24)
		
	tpix:TPixmap=GrabPixmap(0,0,128,64)
	For x=0 To 127
	For y=0 To 63
		argb=ReadPixel(tpix,x,y)
		If (argb & $000000FF)<128 Then argb=$00000000
		WritePixel(tpix,x,y,argb)
	Next
	Next
	RawMisc[0]=ResizePixmap(tpix,1024,512)
	tpix=ResizePixmap(RawMisc[0],800,400)
	ScreenLogo=LoadImage(tpix)
	tpix=Null
	
	Update("Loading Misc")
EndIf


If FileType("backing.png")
	RawMisc[1]=LoadPixmapPNG("backing.png");MiscTot=MiscTot+1



	tPix:TPixmap=LoadPixmapPNG("backing.png")
	upscale=2
	RawScreenName[ScreenTot]="000-Backing"
	RawScreen[ScreenTot]=CreatePixmap(PixmapWidth(tpix)*upscale,PixmapHeight(tpix)*upscale,PF_RGBA8888)
		' Pixel-based resize of screenshots, so that when we scale back down later, they're neater.
		For x=0 To PixmapWidth(tpix)-1
		For y=0 To PixmapHeight(tpix)-1
			argb=ReadPixel(tpix,x,y)
			For ox=0 To upscale-1
			For oy=0 To upscale-1
				WritePixel(RawScreen[ScreenTot],(x*upscale)+ox,(y*upscale)+oy,argb)
			Next
			Next
		Next
		Next
	ScreenTot=ScreenTot+1


Else
	RawMisc[1]=CreatePixmap(2048,2048,PF_RGBA8888)
	r#=0;g#=0;b#=80
	
	For x=0 To 2047
	For y=0 To 2047
		d#=Abs(Sin(x+y)*0.5)+0.5
		argb=$FF000000+(Int(d*r) Shl 16)+(Int(d*g) Shl 8)+(Int(d*b))
		WritePixel(RawMisc[1],x,y,argb)
	Next
	Next
EndIf

If FileType("badge.png")
	RawMisc[2]=LoadPixmapPNG("badge.png");MiscTot=MiscTot+1
Else
	RawMisc[2]=CreatePixmap(128,128,PF_RGBA8888)	
	For x=0 To 127
	For y=0 To 127
		WritePixel(RawMisc[1],x,y,$00000000)
	Next
	Next
EndIf




MiscTot=3

quickdir=ReadDir(CurrentDir$())
Repeat
in$=NextFile(quickdir)
If Upper$(Right$(in$,4))=".PNG" And MiscTot<127 And Lower$(in$)<>"backing.png" And Lower$(in$)<>"logo.png"
	RawMisc[MiscTot]=LoadPixmapPNG(in$)
	MiscTot=MiscTot+1
	Update("Loading Misc")
EndIf
Until in$=""
CloseDir quickdir

Update("Loading Screenshots")

GCCollect()
ChangeDir(Home$+"/01 - Input")
If FileType("Screenshots")=0 Then CreateDir("Screenshots")
ChangeDir(Home$+"/01 - Input/Screenshots")

quickdir=ReadDir(CurrentDir$())
Repeat
in$=NextFile(quickdir)
If Upper$(Right$(in$,4))=".PNG" And ScreenTot<127
	tPix:TPixmap=LoadPixmapPNG(in$)
	upscale=2
	RawScreenName[ScreenTot]=splittext$(in$,".",1)
	RawScreen[ScreenTot]=CreatePixmap(PixmapWidth(tpix)*upscale,PixmapHeight(tpix)*upscale,PF_RGBA8888)
		' Pixel-based resize of screenshots, so that when we scale back down later, they're neater.
	For x=0 To PixmapWidth(tpix)-1
	For y=0 To PixmapHeight(tpix)-1
		argb=ReadPixel(tpix,x,y)
		For ox=0 To upscale-1
		For oy=0 To upscale-1
			WritePixel(RawScreen[ScreenTot],(x*upscale)+ox,(y*upscale)+oy,argb)
		Next
		Next
	Next
	Next
	
	ScreenTot=ScreenTot+1
	Update("Loading Screenshots")
EndIf
Until in$=""
CloseDir quickdir

GCCollect()
ChangeDir(Home$)
End Function


Function Update(line1$,line2$="",line3$="",line4$="")
	Cls
		SetColor(255,255,255);SetAlpha(1.0);SetRotation(0);SetScale(1,1)
		
		If ScreenIcon<>Null Then DrawImage(ScreenIcon,jscrw-64,jscrh-64)
		If ScreenLogo<>Null Then DrawImage(ScreenLogo,jscrw/2,jscrh/2)
		
		DrawText("Icons "+IconTot+" Misc "+MiscTot+" Screens "+ScreenTot+"       Generated "+MadeTot,0,0)
		DrawText(line1,50,30)
		DrawText(line2,100,60)
		DrawText(line3,100,80)
		DrawText(line4,100,110)
		DrawText("[ESC] to quit",16,jscrh-16)
	Flip
End Function





Function SplitText$(in$,Split$,e,alsospace=0)

	'Splits text...
	Local out:String=""
	Local start:Int=1
	Local nomore:Int=0
	Local shift:Int
	Local size:Int

	in:String=Trim(in)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Trim(Mid$(in$,start,size))
	If nomore=1 Then out$="-+-"
	Return out
End Function

